;********************************************************************
;*																	*
;*   Мини ОС реального времени										*
;*   http://easyelectronics.ru										*
;*																	*
;*   Кристал: ATTiny13                                              *
;*																	*
;*	Автоматика управления дворниками для ВАЗ21213					*
;*																	*
;*   interupts.asm - Модуль прерываний								*
;*																	*
;*   Структура проекта:												*
;*		main.asm	- главный модуль (основной цикл)				*
;*		interupts.asm - Модуль прерываний							*
;*		tasks.asm 	- Модуль процессов								*
;* 		taskq.asm	- Модуль очереди процессов						*
;*		timers.asm	- Модуль очереди таймеров						*
;*		data.inc	- Данные в программной памяти					*
;*		define.inc	- Константы и дифайны							*
;*																	*
;********************************************************************

;=== Обработка прерывания по сравнению OCSRA =========================
TC0COMA:
	;спасаем используемые регистры
	push OSWR
	in OSWR, SREG
	push OSWR
	push ZL
	push ZH
	push counter
	;обнуляем счетный регистр
	out TCNT0, zero
	;таймер кнопки
	cp BtnTimerFlag, zero
	breq CompA_L00
	lds ZL, BtnTimer
	lds ZH, BtnTimer + 1
	add	ZL, one
	adc ZH, zero
	sts BtnTimer, ZL
	sts BtnTimer + 1, ZH
CompA_L00:
	;в Я начало очереди таймеров
	ldi ZL, low(TimersQuere)
	ldi ZH, high(TimersQuere)
	ldi counter, TimersQuereSize	;количество таймеров
compA_L01:
	ld OSWR, Z		
	cpi OSWR, $FF	;задачи нет? 
	breq compA_L03	;проверяем следующий таймер
	clt
	ldd OSWR, Z+1		;уменьшаем время таймера на 1
	subi OSWR, low(1)
	std Z+1, OSWR
	breq compA_L02
	set
compA_L02:
	ldd OSWR, Z+2
	sbci OSWR, high(1)
	std Z+2, OSWR
	brne compA_L03
	brts compA_L03
	ld OSWR, Z			;таймер дошел до нуля
	rcall SetTask		;ставим задачу в очередь задач
	ldi OSWR, $FF		;удаляем таймер
	st Z, OSWR
compA_L03:
	subi ZL, Low(-3)
	sbci ZH, High(-3)
	dec counter
	brne compA_L01
	pop counter
	pop ZH
	pop ZL
	pop OSWR 
	out SREG, OSWR
	pop OSWR
	reti
