;********************************************************************
;*																	*
;*   Мини ОС реального времени										*
;*   http://easyelectronics.ru										*
;*																	*
;*   Кристал: ATTiny13                                              *
;*																	*
;*	Автоматика управления дворниками для ВАЗ21213					*
;*																	*
;*		timers.asm	- Модуль очереди таймеров						*
;*																	*
;*   Структура проекта:												*
;*		main.asm	- главный модуль (основной цикл)				*
;*		tasks.asm 	- Модуль процессов								*
;* 		taskq.asm	- Модуль очереди процессов						*
;*		timers.asm	- Модуль очереди таймеров						*
;*		data.inc	- Данные в программной памяти					*
;*		define.inc	- Константы и дифайны							*
;*																	*
;********************************************************************

InitTimersQuery:
	ldi ZL, low(TimersQuere)
	ldi ZH, high(TimersQuere)
	ldi counter, TimersQuereSize
	ldi tmp1, $FF
	cli
ITmQ_L01:
	st Z+, tmp1
	st Z+, zero
	st Z+, zero
	dec counter
	brne ITmQ_L01
	sei
	ret

SetTimer:
	push ZL			;сохраняем используемы регистры
	push ZH
	push tmp2
	push counter
	ldi ZL, low(TimersQuere)		;в Z начало очереди таймеров
	ldi ZH, high(TimersQuere)
	ldi counter, TimersQuereSize	;длина очереди таймеров
ST_L01:
	ld tmp2, Z
	cp tmp2, OSWR
	breq ST_L02
	subi ZL, low(-3)
	sbci ZH, high(-3)
	dec counter
	breq ST_L03
	rjmp ST_L01	
ST_L02:
	std Z+1, XL
	std Z+2, XH
	rjmp ST_L06
ST_L03:
	ldi ZL, low(TimersQuere)
	ldi ZH, high(TimersQuere)
	ldi counter, TimersQuereSize	
ST_L04:
	ld tmp2, Z
	cpi tmp2, $FF
	breq ST_L05
	subi ZL, low(-3)
	sbci ZH, high(-3)
	dec counter
	breq ST_L06
	rjmp ST_L04
ST_L05:
	cli
	st Z, OSWR
	std Z+1, XL
	std Z+2, XH
	sei
ST_L06:
	pop counter
	pop tmp2
	pop ZH
	pop Zl
	ret
			
